<?php
/*
Plugin Name: External Database Management
Plugin URI: http://wordpress.org/support/topic/222660
Description: To manage simple external mySQL database and insert into a wordpress page or post as a table. (See Readme for instructions.) (Updated for WP 2.7) 
Version: 0.2
Author: Driftless1
Author URI: http://www.lbell270.com
*/

/*  Copyright 2008/2009 Driftless1  

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	
    No animals were harmed in the making of this plugin.
*/

/*
IMPORTANT NOTE:
This framework assumes you have at least a basic grasp of mySQL.  
This plugin will not create the table, but rather assumes you have 
created the table already, and know how to connect to it.

The connection information goes into the db_manager_config.php file

To insert a table into your page or post, use <?php insert_ext_db_table() ?>
in a template (or in the post if you have PHP enabled.)
*/


// Hook for adding admin menu
add_action('admin_menu', 'ext_db_admin');

function ext_db_admin() {
	add_menu_page('External Database', 'External DB', delete_others_pages, 'db_manager_admin.php', 'db_manage_page'); 
}


//this function is the back end - to put the DB in the Admin pages for easy access. 
function db_manage_page() {     
							
	include("db_manager_config.php");     //defines connection properties - make sure you have the right info in the db_manager_config.php file
	
	$con = mysql_connect(EXT_DB_HOST, EXT_DB_USER, EXT_DB_PASSWORD, "new");
	if (!$con)
		{
		die('<br />Sorry, we can not connect to the database at this time. Please try to refresh.<br />If the problem persists, please contact the <a href="mailto:">administrator</a>. Thank you.<br /> ' . mysql_error());
		}
	mysql_set_charset(EXT_DB_CHARSET);   // check this... may not work with earlier versions of PHP - I think only PHP 5.0 and above...
	mysql_select_db(EXT_DB_NAME, $con);
	
	echo "<div class='wrap'>";
	echo "<h2>External Database Management Page</h2>";
	
	if(!isset($_GET['ext_db_action'])&&(!isset($_POST['ext_db_action']))) //Show the table as default action	
		{ 
		
		$result = mysql_query("SELECT * FROM entries ORDER BY column1");  // ***EDIT THIS*** your custom mySQL statement to pull the data you want from your table	

		?>
		<!-- this chunk of goodies adds an "add entry" button -->
		<form action="<?php echo $PHP_SELF;?>" method="get">
			<input type="hidden" name="page" value="db_manager_admin.php">
			<input type="hidden" name="ext_db_action" value="edit">
			<input type="hidden" name="entry" value="new">
			<input class="button-primary" type="submit"  value="Add Entry">    
		</form><br />
		
		<div id="ext_db_table_div">  
 		<table id="ext_db_table" class="widefat" border="1">
			<thead>
				<tr>			
					<th scope="col" width="50%">Column1</th>  <!-- ***EDIT THESE*** Change the column headings to whatever you desire... -->
					<th scope="col" width="50%">Column2</th>
					<th scope="col" width="5%">Column3</th>
					<th scope="col" width="5%">Column4</th>  <!-- you get the point - add the columns you want here just be sure the columns below are the same number, or things look funky...-->
				</tr>
			</thead>
			<tbody>
		<?php
				while($ext_db_row = mysql_fetch_array($result))   //While there is data in the array, keep building the table.  Below, you call each column with $ext_db_row['foobar'] where foobar is the heading for each column
					{			
					// in $ext_db_row['db_id'], the 'db_id' should be changed to whatever the uniqe ID (primary key?) column of your mySQL table
						echo "<td><strong><a href='admin.php?page=db_manager_admin.php&ext_db_action=edit&entry=" . $ext_db_row['db_id'] . "'>" . $ext_db_row['column1'] . "</a></strong></td>\n"; //***EDIT THIS*** Change 'db_id' to your uniqe key column, and 'column1' to whatever the column is called in your DB
						if ($ext_db_row['column2'] != null)       	//all this if/else BS is a set of conditionals to display blank spaces if there is no data in a cell... dumb - sure there is a better way, but it works
							echo "<td>" . $ext_db_row['column2'] . "</td>\n";
							else echo "<br/>&nbsp;</td>\n";
						if ($ext_db_row['column3'] != null) 
							echo "<td><a href=\"http://" . $ext_db_row['column3'] . "\" title=\"" . $ext_db_row['column3'] . "\"><img src=\"" . $linkicon . "\" /></a></td>\n";  // these are just examples of using icons and links in a cell.
							else echo "<td>&nbsp;</td>\n";
						if ($ext_db_row['column4'] != null)
							echo "<td><a href=\"" . $fileurl . $ext_db_row['column4'] . "\" title=\"" . $ext_db_row['column4'] . "\"><img src=\"" . $pdficon . "\" /></a></td>\n";
							else echo "<td>&nbsp;</td>\n";
					echo "</tr>\n\n";
					}//end while
			mysql_close($con);  //always good to close the connection
		?>	
			</tbody>
		</table>
		<!-- This next bit is a shameless plug to help a guy keep noodles in his bowl... -->
		<p><small>If you find this plugin useful, please consider a <a href=https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=L47BB483M3Z54&lc=US&item_name=External%20Database%20Manager&item_number=Ext%20DB%20Manage&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted>donation</a></small></p>
		</div> <!-- close div ext_db_table_div-->
	</div> <!-- close div wrap -->
		<?php 
		} 	//end show table default
		
		//starts the "if action = edit" edit the post selected routine
		if($_GET["ext_db_action"]=="edit")
			{
			if (!isset($_POST["submit"]) && !isset($_POST['delete']))    //(that is, as long as the action is not a submit or delete... if it is, go below...)
				{	
				$id = $_GET['entry'];
				if ($id!='new') {
					$result = mysql_query("SELECT * FROM entries WHERE entries.db_id=$id");  //grabs the row by db_id (or whatever your unique key is)
					$editrow = mysql_fetch_array($result);
					}
		?>

<!-- ***EDIT BELOW*** Creates the form for adding / editing entries. Yes this code is not pretty -->
				<form action="<?php echo $PHP_SELF;?>" method="post">
				<input type=hidden name="id" value="<?php echo $editrow["db_id"] ?>">
					Column 1 <small>(Add / edit as needed)</small><br>
					&nbsp;&nbsp;&nbsp;<textarea name="column1" rows=2 cols=60><?php echo $editrow["column1"] ?></textarea><br><br>
					Column 2 <br>
					&nbsp;&nbsp;&nbsp;<textarea name="column2" ROWS=2 COLS=60><? echo $editrow["column2"] ?></textarea><br><br>
					Foo <br>
					&nbsp;&nbsp;&nbsp;<input type="text" name="column3" value="<?php echo $editrow["column3"] ?>" size ="65" /><br><br>
					Bar <small>(Hi mom!)</small><br />
					&nbsp;&nbsp;&nbsp;<input type="text" name="column4" value="<?php echo $editrow["column4"] ?>" size ="65" /><br><br>
					
				<?php if ($id != 'new') {
					echo '<input type="hidden" name="ext_db_action" value="edit">';
					echo '<input class="button" type="submit" name="submit" value="Update">';
					echo '<input class="button" type="submit" name="delete" value="Delete">';
					}
					else {
						echo '<input class="button" type="submit" name="submit" value="Add">'; 
						}
				echo '</form>';
				} //end edit form 
		
			// ***EDIT BELOW***  This function tells the db to update the record when the submit button is hit...
			if ($_POST['submit'])
				{
				$id = $_POST["id"];					
				$column1 = $_POST["column1"];
				if (empty($column1)) $column1 = 'NULL';			// the if statements below allow null characters to be entered into the DB... a major pain, but necessary, otherwise the mySQL database is populated with blanks (not NULL)
					else $column1 = '\'' . $column1 . '\'';
				$column2 = $_POST["column2"];
				if (empty($column2)) $column2 = 'NULL';	
					else $column2 = '\'' . $column2 . '\'';
				$column3 = $_POST["column3"];
				if (empty($column3)) $column3 = 'NULL';	
					else $column3 = '\'' . $column3 . '\'';
				$column4 = $_POST["column4"];
				if (empty($column4)) $column4 = 'NULL';	
					else $column4 = '\'' . $column4 . '\'';	
								
				if ($_GET['entry']!='new'){  				//if its not a "new" entry then update the record.
					$sqlupdate = "UPDATE entries SET column1=$column1, column2=$column2, column3=$column3, column4=$column4 WHERE db_id='$id' LIMIT 1";  //***EDIT THIS***
					$results = mysql_query($sqlupdate);
					if (!($results))
						{	
						die ('ERROR: There appears to be an error with the database (' . mysql_error() .') Please try again.');
						}
						?>					
						Great! Information Updated.						
						<form method="get"><br />  <!--Return button-->
						<input type="hidden" name="page" value="db_manager_admin.php">
						<input class="button" type="submit" value="Return">
						</form>
						</div>
						<?php
					unset($id, $sqlupdate);
					mysql_close($con);
					}
					else { 						 //if it is a "new" entry, than call the insert! function instead of uipdated.
						$sqlinsert = "INSERT INTO entries (column1, column2, column3, column4) VALUES ($column1, $column2, $column3, $column4)"; //***EDIT THIS***
						$results = mysql_query($sqlinsert);
						if (!($results))
						  {	
						  die ('ERROR: There appears to be an error with the database (' . mysql_error() .') Please try again.');
						  }
			?>					
						Great! Data has been entered.						
						<form method="get"><br />  <!--Return button-->
						<input type="hidden" name="page" value="db_manager_admin.php">
						<input class="button" type="submit" value="Return">
						</form>
						</div>
			<?php
						mysql_close($con);
						}
				} 	// end if post = submit

				if($_POST['delete'] == "Delete")  //begin the delete function
					{
						echo "<br>Whoa! Are you sure you want to delete this record? Click 'Yes' or use your browsers back button.";
			?>
					<form action="<?php echo $PHP_SELF;?>" method="post"><br />
						<input type="hidden" name="ext_db_action" value="edit">
						<input class="button" type="submit" name="delete" value="yes">
					</form>
					</div>
			<?php
					}
			if ($_POST['delete'] == "yes")
				{
				$id = $_GET["entry"];
				$sqlupdate = "DELETE FROM entries WHERE entries.db_id='$id' LIMIT 1";  //***EDIT THIS***
				$results = mysql_query($sqlupdate);
				if (!($results))
					{	
					die ('ERROR: There appears to be an error with the database (' . mysql_error() .') Please try again.');
					}
				?>	
				<br>Thank you! Your entry has been annihilated. 
				<form method="get"><br />  <!--Return button-->
					<input type="hidden" name="page" value="db_manager_admin.php">
					<input class="button" type="submit" value="Return">
				</form>
				</div>
				<?php	
					mysql_close($con);
					unset($id, $sqlupdate);
				}
			} //end if get = edit 
} //ends the db_manage_page admin functions





function insert_ext_db_table(){  //begin insert table function - use this to call the formatted table in the page or post. 
	include("db_manager_config.php");     //defines connection properties
	$con = mysql_connect(EXT_DB_HOST, EXT_DB_USER, EXT_DB_PASSWORD, "new");
	if (!$con)
	  {
	  die('<br />Sorry, we can not connect to the database at this time. Please try to refresh.<br />If the problem persists, please contact the <a href="mailto:">administrator</a>. Thank you.<br /> ' . mysql_error());
	  }

	mysql_set_charset(EXT_DB_CHARSET); 
	mysql_select_db(EXT_DB_NAME, $con);
	$result = mysql_query("SELECT * FROM entries ORDER BY column1");    // ***EDIT THIS*** your custom mySQL statement to pull the data you want from your table
	
	echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/ext-db-manage/db_manager_table.css" />' . "\n";
	?>
	<h2> My Table </h2>
	<p class="post-info">Preamble - what is the table all about?</p>
								
	<div id="ext_db_table_div">   
 		<table id="ext_db_table">
			<thead>
				<tr>
					<th scope="col" width="50%">Column1</th>  <!-- EDIT THESE -->
					<th scope="col" width="50%">Column2</th>
					<th scope="col" width="5%">Column3</th>
					<th scope="col" width="5%">Column4</th>  <!-- you get the point - add the columns you want here -->
				</tr>
			</thead>
			<tbody>
		<?php

		while($ext_db_row = mysql_fetch_array($result))   //While there is data in the array, keep building the table.  Call each column with $ext_db_row['foobar'] where foobar is the heading for each column
			{		
			// the $ext_db_row['db_id'] should be changed to whatever the uniqe ID (primary key?) column of your mySQL table
			echo "<td>" . $ext_db_row['column1'] . "</a></strong></td>\n"; 		//***EDIT THESE***
			if ($ext_db_row['column1'] != null)       							//all this if/else BS is a set of conditionals to display blank spaces if there is no data in a cell... dumb - sure there is a better way, but it works
				echo "<td>" . $ext_db_row['column2'] . "</td>\n";
				else echo "<br/>&nbsp;</td>\n";
			if ($ext_db_row['column2'] != null) 
				echo "<td><a href=\"http://" . $ext_db_row['column3'] . "\" title=\"" . $ext_db_row['column3'] . "\"><img src=\"" . $linkicon . "\" /></a></td>\n";
				else echo "<td>&nbsp;</td>\n";
			if ($ext_db_row['column3'] != null)
				echo "<td><a href=\"" . $fileurl . $ext_db_row['column4'] . "\" title=\"" . $ext_db_row['column4'] . "\"><img src=\"" . $pdficon . "\" /></a></td>\n";
				else echo "<td>&nbsp;</td>\n";
			echo "</tr>\n\n";
			}//end while


		mysql_close($con);  //always good to close the connection
		?>	
			</tbody>
			</table>
		</div> <!-- close div ext_db_table_div-->
<?php
} //ends the insert table function
?>